Assignments Assignments

Classes | Macros | Typedefs | Functions | Variables
jdhuff.cpp File Reference
`#include "jinclude.h"`
`#include "jpeglib.h"`
`#include "jdhuff.h"`

## Classes
struct | savable_state
struct | huff_entropy_decoder

## Macros
#define | JPEG_INTERNALS
#define | ASSIGN_STATE(dest, src) ((dest) = (src))
#define | MIN_GET_BITS (BIT_BUF_SIZE-7)
#define | HUFF_EXTEND(x, s) ((x) < extend_test[s] ? (x) + extend_offset[s] : (x))

## Typedefs
typedef huff_entropy_decoder * | huff_entropy_ptr

## Functions
| start_pass_huff_decoder (j_decompress_ptr cinfo)
| jpeg_make_d_derived_tbl (j_decompress_ptr cinfo, boolean isDC, int tblno, d_derived_tbl **pdtbl)
| jpeg_fill_bit_buffer (bitread_working_state *state, register bit_buf_type get_buffer, register int bits_left, int nbits)
| jpeg_huff_decode (bitread_working_state *state, register bit_buf_type get_buffer, register int bits_left, d_derived_tbl *htbl, int min_bits)
| process_restart (j_decompress_ptr cinfo)
| decode_mcu (j_decompress_ptr cinfo, JBLOCKROW *MCU_data)
| jinit_huff_decoder (j_decompress_ptr cinfo)

## Variables
static const int | extend_test [16]
static const int | extend_offset [16]

## Macro Definition Documentation

## ◆ ASSIGN_STATE

#define ASSIGN_STATE | ( |  | dest,
|  |  | src ) ((dest) = (src))

## ◆ HUFF_EXTEND

#define HUFF_EXTEND | ( |  | x,
|  |  | s ) ((x) < extend_test[s] ? (x) + extend_offset[s] : (x))

## ◆ JPEG_INTERNALS

#define JPEG_INTERNALS

## ◆ MIN_GET_BITS

#define MIN_GET_BITS (BIT_BUF_SIZE-7)

## Typedef Documentation

## ◆ huff_entropy_ptr

typedef huff_entropy_decoder* huff_entropy_ptr

## Function Documentation

## ◆ decode_mcu()

decode_mcu | ( | j_decompress_ptr | cinfo,
|  | JBLOCKROW * | MCU_data )

## ◆ jinit_huff_decoder()

jinit_huff_decoder | ( | j_decompress_ptr | cinfo | ) |

## ◆ jpeg_fill_bit_buffer()

jpeg_fill_bit_buffer | ( | bitread_working_state * | state,
|  | register bit_buf_type | get_buffer,
|  | register int | bits_left,
|  | int | nbits )

## ◆ jpeg_huff_decode()

jpeg_huff_decode | ( | bitread_working_state * | state,
|  | register bit_buf_type | get_buffer,
|  | register int | bits_left,
|  | d_derived_tbl * | htbl,
|  | int | min_bits )

## ◆ jpeg_make_d_derived_tbl()

jpeg_make_d_derived_tbl | ( | j_decompress_ptr | cinfo,
|  | boolean | isDC,
|  | int | tblno,
|  | d_derived_tbl ** | pdtbl )

## ◆ process_restart()

process_restart | ( | j_decompress_ptr | cinfo | ) |

## ◆ start_pass_huff_decoder()

start_pass_huff_decoder | ( | j_decompress_ptr | cinfo | ) |

## Variable Documentation

## ◆ extend_offset

const int extend_offset[16]
| static

Initial value:
=
{ 0, ((-1)<<1) + 1, ((-1)<<2) + 1, ((-1)<<3) + 1, ((-1)<<4) + 1,
((-1)<<5) + 1, ((-1)<<6) + 1, ((-1)<<7) + 1, ((-1)<<8) + 1,
((-1)<<9) + 1, ((-1)<<10) + 1, ((-1)<<11) + 1, ((-1)<<12) + 1,
((-1)<<13) + 1, ((-1)<<14) + 1, ((-1)<<15) + 1 }

## ◆ extend_test

const int extend_test[16]
| static

Initial value:
=
{ 0, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080,
0x0100, 0x0200, 0x0400, 0x0800, 0x1000, 0x2000, 0x4000 }